<%--
 * Copyright by Intland Software
 *
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Intland Software. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Intland.
 *
 * $Revision:19952 $ $Date:2007-08-24 19:13:25 +0200 (Fri, 24 Aug 2007) $
--%>

<%@ taglib uri="jstl-c" prefix="c" %>
<%@ taglib uri="jstl-fmt" prefix="fmt" %>
<%@ taglib uri="jstl-fn" prefix="fn" %>

<%@ taglib uri="struts-html" prefix="html" %>

<%@ taglib uri="taglib" prefix="tag" %>

<c:set var="requestURI" value="${param.requestURI}"/>
<c:set var="newTransURI" value="${param.newTransURI}"/>
<c:set var="actionForm" value="${param.actionForm}"/>

<%-- TODO: merge meta headers --%>
<meta name="decorator" content="main">
<meta name="moduleCSSClass" content="trackersModule">
<meta name="stylesheet" content="tracker.css">

<c:choose>
	<c:when test="${trackerTransitionPermissionForm.tracker.category}">
		<meta name="module" content="cmdb">
	</c:when>
	<c:otherwise>
		<meta name="module" content="tracker">
	</c:otherwise>
</c:choose>

<c:set var="tracker_id" value="${param.tracker_id}" />

<c:url var="newTransitionURL" value="${newTransURI}">
	<c:param name="tracker_id" value="${tracker_id}" />
</c:url>

<c:set var="newTransitionClick" value="launch_url('${newTransitionURL}',true);return false;" />

<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!-- Hide script from old browsers
function editTransition(frm) {
	var tid = -1;
	var numelems = frm.elements.length;
	for (var i=0 ; i< numelems; i++) {
		var elem = frm.elements[i];
		if (elem.name == "selectedTransitionId" && elem.checked) {
			tid = elem.value;
		}
	}

	if (tid == -1) {
		alert("You must select a transition");
		return false;
	}
//	alert(tid);
	launch_url('<c:out value="${newTransitionURL}" />&transitionId=' + tid,true);return false;
//	location.href='<c:out value="${newTransitionURL}" />&transitionId=' + tid;
}

function confirmDelete() {
	return confirm(<fmt:message key="tracker.transition.delete.confirm" />);
}

// -->
</SCRIPT>

<c:set var="nr_of_roles" value="${fn:length(roles)}" />

<c:set var="order_by" value="${param.order_by}" />
<c:if test="${empty order_by}">
	<c:set var="order_by" value="from" />
</c:if>

<c:set var="ascend" value="${param.ascend}" />
<c:if test="${empty ascend}">
	<c:set var="ascend" value="ASC" />
</c:if>

<html:form styleId="adminTransitionPermissionForm" action="${actionForm}">

<html:hidden property="tracker_id" />

<c:set var="controlButtons">
	<c:choose>
		<c:when test="${canAdminPermission}">
			&nbsp;&nbsp;<html:submit styleClass="button" value="Save" />

			<c:if test="${licenseCode.enabled.customWorkflow}">
				&nbsp;&nbsp;<html:button styleClass="button" property="EDIT"
					onclick="editTransition(this.form)" value="Edit" />

				&nbsp;&nbsp;<html:button styleClass="button" property="NEW"
					onclick="${newTransitionClick}" value="New" />

				&nbsp;&nbsp;<html:submit styleClass="button" property="DELETE"
					onclick="return confirmDelete();" value="Delete..." />
			</c:if>
		</c:when>
		<c:otherwise>
			<script language="javascript">
				YAHOO.util.Event.onDOMReady(function() {
					setEditFieldsDisabled(document.getElementById("adminTransitionPermissionForm"), true);
				});
			</script>
		</c:otherwise>
	</c:choose>

	&nbsp;&nbsp;<html:cancel styleClass="button" />
</c:set>

<div class="actionBar">
	<c:out value="${controlButtons}" escapeXml="false" />
</div>

<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">

<TR>
	<TH CLASS="textCenterData" COLSPAN="6">Transitions</TH>

	<tag:tableColumnSeparator header="false" />

	<TH CLASS="textCenterData" COLSPAN="3">Account</TH>

	<tag:tableColumnSeparator header="false" />

	<TH CLASS="textCenterData" COLSPAN="<c:out value="${nr_of_roles * 3}" />">Roles</TH>
</TR>

<TR>
	<TD HEIGHT="1" CLASS="colseparator" COLSPAN="<c:out value="${nr_of_roles * 2 + 5 + 5}" />"></TD>
</TR>

<TR CLASS="head">
	<TH> </TH>

	<tag:sortableHeaderLink
		label="From" orderBy="${order_by}" ascend="${ascend}"
		link="from" />

	<tag:tableColumnSeparator header="true" />

	<tag:sortableHeaderLink
		label="To" orderBy="${order_by}" ascend="${ascend}"
		link="to" />

	<tag:tableColumnSeparator header="true" />

	<tag:sortableHeaderLink
		label="Label" orderBy="${order_by}" ascend="${ascend}"
		link="label" />

	<tag:tableColumnSeparator header="false" />

	<TH CLASS="textData">Submitter</TH>

	<tag:tableColumnSeparator header="true" />

	<TH CLASS="textData">Assignee</TH>

	<tag:tableColumnSeparator header="false" />

	<c:forEach items="${roles}" var="role" varStatus="status">
		<TH CLASS="textData"><c:out value="${role.description}" /></TH>

		<c:if test="${!status.last}">
			<tag:tableColumnSeparator header="true" />
		</c:if>
	</c:forEach>
</TR>

<%
	int counter = 1;
%>
<c:forEach items="${transitions}" var="transition">
	<TR VALIGN="top" CLASS="<%=((counter++ % 2) == 0 ? "even" : "odd")%>">

		<TD valign="middle">
			<c:if test="${licenseCode.enabled.customWorkflow}">
				<html:radio property="selectedTransitionId" value="${transition.id}" ondblclick="editTransition(this.form)" />
			</c:if>
		</TD>

		<TD CLASS="textData" valign="middle"><c:out value="${transition.fromStatusName}" default="Unset" /></TD>

		<tag:tableColumnSeparator />

		<TD CLASS="textData" valign="middle"><c:out value="${transition.toStatusName}" default="Unset" /></TD>

		<tag:tableColumnSeparator />

		<TD CLASS="textData" valign="middle"><c:out value="${transition.label}" /></TD>

		<tag:tableColumnSeparator />

		<TD CLASS="textCenterData" valign="middle"><html:checkbox property="submitterGranted(${transition.id})" /></TD>

		<tag:tableColumnSeparator />

		<TD CLASS="textCenterData" valign="middle"><html:checkbox property="assigneeGranted(${transition.id})" /></TD>

		<c:forEach items="${roles}" var="role">
			<tag:tableColumnSeparator />

			<c:set var="idx" value="${transition.id}-${role.id}" />
			<TD CLASS="textCenterData" valign="middle"><html:checkbox property="roleGranted(${idx})" /></TD>
		</c:forEach>
	</TR>
</c:forEach>

</TABLE>

</html:form>
